/********************************************************************************
Desarrollado por:   Globant de México
Proyecto:           TOYOTA TAM
Descripción:        Clase Batch para Provisión de Incentivos - Ventas Corporativas
________________________________________________________________
Autor               Fecha               Descripción
________________________________________________________________
Cecilia Cruz        30/Jun/2020         Versión Inicial
Cecilia Cruz        26/Ago/2021         Se añade regla de boletin: 
                                        "Si es fleet C y excede 90 dias. no se paga incentivo."
Cecilia Cruz        19/Oct/2021         Modificación de regla Fleet N, permite provisionar 
                                        un VIN con 3 meses de antiguedad siempre que no presente un RVRSL.
Cecilia Cruz        21/Oct/2021         Remover fecha de autorización en consulta de Reversas.
Cecilia Cruz        03/Nov/2021         -Actualización de regla: Una VC de Fleet N no puede cerrar con RDR en meses anteriores.
                                        -Actualización de regla: No exceder 90 días con la fecha de cierre de ventas calendario Toyota.
________________________________________________________________
*********************************************************************************/
public class TAM_ProvisionHelperClass {

    //Constantes
    static final String STRING_EXCEPCION = 'Excepción';
    static final String STRING_TIPO_MOVIMIENTO_RDR = 'RDR';
    static final String STRING_TIPO_MOVIMIENTO_RVRSL = 'RVRSL';
    static final String STRING_CODIGO_DEALER_57000 = '57000';
    static final String STRING_ESTATUS_VIGENTE = 'Vigente';
    static final String STRING_ESTATUS_APROBADO = 'Aprobado';
    static final String STRING_ESTATUS_RECHAZADA = 'Rechazada';
    static final String STRING_ESTATUS_RECHAZADO = 'Rechazado';
    static final String STRING_ESTATUS_PENDIENTE = 'Pendiente';
    static final String STRING_ESTATUS_ALTA_RECHAZADA_TMEX = 'Alta rechazada por TMEX' ;
    static final String STRING_ESTATUS_ALTA_RECHAZADA_TFS = 'Alta rechazada por TFS';
    static final String STRING_ESTATUS_FINANZAS_PAGO_AUTORIZADO_TMEX = 'Pago Autorizado TMEX';
    static final String STRING_ESTATUS_FINANZAS_AUTORIZADO_PARA_PAGO = 'Autorizado para pago';
    static final String STRING_ESTATUS_FINANZAS_FACTURADO_DEALER = 'Facturado por el Dealer';
    static final String STRING_ESTATUS_EDO_CTA_ENVIADO_A_FACTURAR = 'Enviado a Facturar';
    static final String STRING_STANDARPRICEBOOK_NAME = 'Standard Price Book';
    static final String STRING_CLASIFICACION_SIN_REVERSA = 'Sin Reversa';
    static final String STRING_CLASIFICACION_CON_REVERSA = 'Con Reversa';
    static final String STRING_CLASIFICACION_EXCEPCION_VENTA_CORPORATIVA = 'Excepción Venta Corporativa';
    static final String STRING_FACTURA_DDD = 'DDD';
    static final String STRING_FACTURA_DDDD = 'DDDD';
    static final String STRING_FACTURA_DDDDD = 'DDDDD';
    static final String STRING_FACTURA_DDDDDDDDD = 'DDDDDDDDD';
    static final String STRING_FACTURA_DDDDDDDDDD = 'DDDDDDDDDD';
    static final String STRING_FACTURA_AUTODEMO = 'AUTO DEMO';
    static final String STRING_FACTURA_0 = '0';
    static final String STRING_FACTURA_00 = '00';
    static final String STRING_FACTURA_000 = '000';
    static final String STRING_FACTURA_0000 = '0000';
    static final String STRING_FACTURA_00000 = '000000';
    static final String STRING_FACTURA_A0000 = 'A0000';
    static final String STRING_FACTURA_A000000000 = 'A000000000';
    static final String STRING_FACTURA_AAGS = 'AAGS';
    static final String STRING_FACTURA_FFFF = 'FFFF';
    static final String STRING_FACTURA_FFFFF = 'FFFFF';
    static final String STRING_FACTURA_FFFFFF = 'FFFFFF';
    static final String STRING_FACTURA_FFFFFFF = 'FFFFFFF';
    static final String STRING_FACTURA_FLT = 'FLT';
    static final String STRING_FACTURA_FNC = 'FNC';
    static final String STRING_FACTURA_FNCT = 'FNCT';
    static final String STRING_FACTURA_SF = 'S/F';
    static final String STRING_FACTURA_VD = 'VD';
    static final String STRING_TIPO_VENTACORPORATIVA = 'VentaCorporativa';
    static final String STRING_TIPO_VENTA_CORPORATIVA = 'Venta Corporativa';
    static final String STRING_MOTIVO_DESCARTE_PROVISIONADO= 'El VIN fue provisionado previamente en un rango de 3 meses.';
    static final String STRING_MOTIVO_DESCARTE_SIN_INCENTIVO= 'El VIN no presenta un incentivo vigente.';
    static final String STRING_MOTIVO_DESCARTE_DEMO= 'El VIN se encuentra registrado como Auto Demo.';
    static final String STRING_MOTIVO_DESCARTE_FLEET_N_RVRSL= 'Fleet N con RVRSL.';
    static final String STRING_MOTIVO_DESCARTE_FLEET_C_90_DIAS= 'Excede 90 días.';
    static final String STRING_MOTIVO_DESCARTE_REVERSADO= 'Con Reversa.';
    static final String STRING_MOTIVO_DESCARTE_EDO_CTA= 'Ya se encuentra registrado en un Estado de Cuenta.';
    static final String STRING_MOTIVO_DESCARTE_HISTORICO_MACROS= 'Registrado en historico de macros.';
    static final String STRING_MOTIVO_DESCARTE_SIN_FACTURA= 'Sin factura cargada.';
    static final String STRING_MOTIVO_DESCARTE_SIN_VC= 'No es Venta Corporativa';

    //Tipos de Registros
    static final Id RECORDTYPEID_POLITICAINCENTIVOS_VENTACORPORATIVA = Schema.SObjectType.TAM_PoliticasIncentivos__c.getRecordTypeInfosByName().get('Venta Corporativa').getRecordTypeId();
    static final Id RECORDTYPEID_DETALLEINCENTIVOS_VENTACORPORATIVA = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('Venta Corporativa').getRecordTypeId();
    static final Id RECORDTYPEID_DETALLEINCENTIVOS_RETAIL = Schema.SObjectType.TAM_DetalleProvisionIncentivo__c.getRecordTypeInfosByName().get('Retail').getRecordTypeId();
    static final Id RECORDTYPEID_DETALLEEDOCTA_FLOTILLA = Schema.SObjectType.TAM_DetalleEstadoCuenta__c.getRecordTypeInfosByName().get('Flotilla').getRecordTypeId();
    
    //Variables Publicas
    public static Map<String, TAM_SolicitudesFlotillaPrograma__c> mapVtaCorporativaDatosClienteInvent {get;set;}
    public static Map<String, TAM_SolicitudesFlotillaPrograma__c> mapVtaCorporativaDatosCliente {get;set;}
    public static Map<String, Factura__c> mapFacturasDetalle {get;set;}
    public static Map<String, PricebookEntry> mapListaPrecops {get;set;}

    //Obtener fecha de ultima provision generada.
    public static DateTime getFechaUltimaProvision(){
        DateTime datUltimaProv;
        List<TAM_ProvisionIncentivos__c> lstProvision = [SELECT Id,CreatedDate FROM TAM_ProvisionIncentivos__c ORDER BY CreatedDate DESC LIMIT 2];
        if(!lstProvision.isEmpty()){
            datUltimaProv = lstProvision[1].CreatedDate;
        }
        return datUltimaProv;
    }
    
    //Obtener Lista de movimientos completos de los vines reportados en el mes en DD
    public static List<Movimiento__c> getListMov(Set<String> setAllVinesDelMesFlotilla){
        List<Movimiento__c> lstMovimientosFlotillas = [SELECT  VIN__r.Name,
                                                       VIN__r.Id,
                                                       VIN__r.Total_de_Movimientos_Reversa__c,
                                                       Modelo__r.NombreVersion__c,
                                                       Modelo__r.Name,
                                                       Modelo__r.IdExternoProducto__c,
                                                       TAM_Serie__c, 
                                                       Year_Modelo__c,
                                                       Sale_Code__c,
                                                       Distribuidor__r.Name,
                                                       Distribuidor__r.Codigo_Distribuidor__c,
                                                       First_Name__c,
                                                       Last_Name__c,
                                                       NombreCliente__c,
                                                       Submitted_Date__c,
                                                       Trans_Type__c,
                                                       Sale_Date__c,
                                                       Factura__c,
                                                       Fleet__c,
                                                       Year__c,
                                                       Month__c,
                                                       VIN__r.Ultimo_Movimiento__c,
                                                       VIN__r.Ultimo_Movimiento__r.Trans_Type__c,
                                                       VIN__r.Ultimo_Movimiento__r.NombreCliente__c,
                                                       VIN__r.Ultimo_Movimiento__r.Submitted_Date__c,
                                                       VIN__r.Ultimo_Movimiento__r.Sale_Date__c,
                                                       TAM_MesAnio__c
                                                       FROM    Movimiento__c
                                                       WHERE   VIN__r.Name IN: setAllVinesDelMesFlotilla
                                                       AND	    Distribuidor__r.Codigo_Distribuidor__c !=: STRING_CODIGO_DEALER_57000
                                                       ORDER BY VIN__r.Ultimo_Movimiento__r.NombreCliente__c, Name ASC, Distribuidor__r.Codigo_Distribuidor__c];
        return lstMovimientosFlotillas;
    }
    
    //Obtener Movimientos Flotilla.
    public static Map<String, List<Movimiento__c>> getMovimientosFlotilla(Set<String> setAllVinesDelMesFlotilla){
        List<Movimiento__c> lstMovFlotilla = new List<Movimiento__c>();	
        for (Movimiento__c objMov : [SELECT  VIN__r.Name,
                                     VIN__r.Id,
                                     VIN__r.Total_de_Movimientos_Reversa__c,
                                     Modelo__r.NombreVersion__c,
                                     Modelo__r.Name,
                                     Modelo__r.IdExternoProducto__c,
                                     TAM_Serie__c, 
                                     Year_Modelo__c,
                                     Sale_Code__c,
                                     Distribuidor__r.Name,
                                     Distribuidor__r.Codigo_Distribuidor__c,
                                     First_Name__c,
                                     Last_Name__c,
                                     NombreCliente__c,
                                     Submitted_Date__c,
                                     Trans_Type__c,
                                     Sale_Date__c,
                                     Factura__c,
                                     Fleet__c,
                                     Year__c,
                                     Month__c,
                                     VIN__r.Ultimo_Movimiento__c,
                                     VIN__r.Ultimo_Movimiento__r.Trans_Type__c,
                                     VIN__r.Ultimo_Movimiento__r.NombreCliente__c,
                                     VIN__r.Ultimo_Movimiento__r.Submitted_Date__c,
                                     VIN__r.Ultimo_Movimiento__r.Sale_Date__c,
                                     VIN__r.Ultimo_Movimiento__r.TAM_MesAnio__c,
                                     TAM_MesAnio__c
                                     FROM    Movimiento__c
                                     WHERE   VIN__r.Name IN: setAllVinesDelMesFlotilla
                                     AND	    Distribuidor__r.Codigo_Distribuidor__c !=: STRING_CODIGO_DEALER_57000
                                     ORDER BY Distribuidor__r.Codigo_Distribuidor__c ASC, Submitted_Date__c ASC, Submitted_Time__c ASC]){
                                         lstMovFlotilla.add(objMov);
                                     }
        
        // map de mov
        Map<String, List<Movimiento__c>> mapMovimientosFlotilla = new Map<String, List<Movimiento__c>>();
        List<Movimiento__c> lstMovAux = new List<Movimiento__c>();
        for(Movimiento__c objMov : lstMovFlotilla){
            String strVIN_Name = objMov.VIN__r.Name;
            lstMovAux = mapMovimientosFlotilla.get(strVIN_Name);
            if(mapMovimientosFlotilla.containsKey(strVIN_Name)){
                if(!lstMovAux.contains(objMov)){
                    lstMovAux.add(objMov);
                    mapMovimientosFlotilla.put(strVIN_Name, lstMovAux);
                }
            } else {
                lstMovAux = new List<Movimiento__c>();
                lstMovAux.add(objMov);
                mapMovimientosFlotilla.put(strVIN_Name, lstMovAux);
            }
        }
        return mapMovimientosFlotilla;
    }
    
    //Obtener Mapa de Incentivos Flotilla
    public static Map<String, List<TAM_DetallePoliticaJunction__c>> getIncentivosFlotilla(String strAnio, String strMes){
        Integer intMes = Integer.valueOf(strMes);
        Integer intAnio = Integer.valueOf(strAnio);
        List<TAM_DetallePoliticaJunction__c> lstIncentivosFlotilla = new List<TAM_DetallePoliticaJunction__c>();
        for (TAM_DetallePoliticaJunction__c objPolticaIncentivos : [SELECT 	ID,
                                                                    TAM_IncPropuesto_Porcentaje__c, TAM_IncentivoTMEX_Porcentaje__c, TAM_IncDealer_Porcentaje__c,
                                                                    TAM_TP_IncTMEX_Cash__c, TAM_IncentivoTMEX_Cash__c, TAM_ProductoFinanciero__c,
                                                                    TAM_AnioModelo__c, TAM_Serie__c, TAM_Clave__c, Name,
                                                                    TAM_PoliticaIncentivos__c, TAM_PoliticaIncentivos__r.Id, TAM_PoliticaIncentivos__r.Name,
                                                                    TAM_PoliticaIncentivos__r.TAM_InicioVigencia__c, TAM_PoliticaIncentivos__r.TAM_FinVigencia__c,
                                                                    TAM_Rango__c, TAM_Rango__r.RecordType.DeveloperName, TAM_Rango__r.Name
                                                                    FROM 	TAM_DetallePoliticaJunction__c
                                                                    WHERE 	TAM_PoliticaIncentivos__r.RecordType.Id =:RECORDTYPEID_POLITICAINCENTIVOS_VENTACORPORATIVA
                                                                    AND 	TAM_PoliticaIncentivos__r.TAM_EstatusIncentivos__c =:STRING_ESTATUS_VIGENTE]){
                                                                        //Agregarlo a la lista de lstIncentivosFlotilla
                                                                        lstIncentivosFlotilla.add(objPolticaIncentivos);
                                                                    }
        Map<String, List<TAM_DetallePoliticaJunction__c>> mapIncentivosFlotilla = new Map<String, List<TAM_DetallePoliticaJunction__c>>();
        List<TAM_DetallePoliticaJunction__c> lstDetalleAux = new List<TAM_DetallePoliticaJunction__c>();
        for(TAM_DetallePoliticaJunction__c objDetalleIncentivo : lstIncentivosFlotilla){
            String idDetallePolitica = objDetalleIncentivo.TAM_AnioModelo__c + '-'+ objDetalleIncentivo.TAM_Clave__c;
            lstDetalleAux = mapIncentivosFlotilla.get(idDetallePolitica);
            if(mapIncentivosFlotilla.containsKey(idDetallePolitica)){
                if(!lstDetalleAux.contains(objDetalleIncentivo)){
                    lstDetalleAux.add(objDetalleIncentivo);
                    mapIncentivosFlotilla.put(idDetallePolitica, lstDetalleAux);
                }
            } else {
                lstDetalleAux = new List<TAM_DetallePoliticaJunction__c>();
                lstDetalleAux.add(objDetalleIncentivo);
                mapIncentivosFlotilla.put(idDetallePolitica, lstDetalleAux);
            }
        }
        return mapIncentivosFlotilla;
    }
    
    //Obtener Excepciónes flotilla
    public static Map<String, TAM_SolicitudExpecionIncentivo__c> getExcepcionesFlotilla(String strAnio, String strMes, String VaRtExcepVtaCorpo){
        Integer intMesActual = Integer.valueOf(strMes);
        Integer intAnioActual = Integer.valueOf(strAnio);
        Integer intMesAnterior;
        Integer intAnio;
        if(strMes == '1'){
            intMesAnterior = 12;
            intAnio = Integer.valueOf(strAnio) - 1;
        } else{
            intMesAnterior = Integer.valueof(strMes) - 1;
            intAnio = Integer.valueof(strAnio);
        }
        List<TAM_SolicitudExpecionIncentivo__c> lstExcepcionVtaCorp =  [SELECT	Id,
                                                                                TAM_PoliticaSeleccionada__c,
                                                                                TAM_PoliticaSeleccionada__r.TAM_PoliticaIncentivos__r.Id,
                                                                                TAMVIN__c,
                                                                                TAM_listaVINES__c,
                                                                                TAM_PoliticaSeleccionada__r.TAM_Pago_TFS__c,
                                                                                TAM_PoliticaSeleccionada__r.TAM_IncentivoTMEX_Cash__c,
                                                                                TAM_PoliticaSeleccionada__r.TAM_IncDealer_Cash__c,
                                                                                TAM_PoliticaSeleccionada__r.TAM_IncPropuesto_Cash__c
                                                                        FROM	TAM_SolicitudExpecionIncentivo__c
                                                                        WHERE 	TAM_AprobacionFinanzas__c =: STRING_ESTATUS_APROBADO
                                                                        AND 	RecordTypeId = :VaRtExcepVtaCorpo
                                                                        AND		( CALENDAR_MONTH(TAM_Fecha_Autorizacion_Finanzas__c) =: intMesAnterior
                                                                    	            OR  CALENDAR_MONTH(TAM_Fecha_Autorizacion_Finanzas__c) =: intMesActual)
                                                                        AND    	( CALENDAR_YEAR(TAM_Fecha_Autorizacion_Finanzas__c) =: intAnio
                                                                                    OR  CALENDAR_YEAR(TAM_Fecha_Autorizacion_Finanzas__c) =: intAnioActual)];
        Map<String, TAM_SolicitudExpecionIncentivo__c> mapExcepcionesFlotilla = new Map<String, TAM_SolicitudExpecionIncentivo__c>();
        for(TAM_SolicitudExpecionIncentivo__c objExcepcion : lstExcepcionVtaCorp){
            mapExcepcionesFlotilla.put(objExcepcion.TAMVIN__c, objExcepcion);
        }
        return mapExcepcionesFlotilla;
    }
    
    //Obtener VINES de Estado de Cuenta
    public static Map<String, TAM_DetalleEstadoCuenta__c> getEstadoCuentaFlotilla(Set<String> setAllVinesDelMesFlotilla){
        Map<String, TAM_DetalleEstadoCuenta__c> mapEdoCuentaFlotilla = new Map<String, TAM_DetalleEstadoCuenta__c>();        
        for (TAM_DetalleEstadoCuenta__c objDetEdoCta : [SELECT	Id,
                                                                TAM_VIN__c,
                                                                TAM_Estatus_Finanzas__c,
                                                                TAM_Fecha_Pago__c,
                                                                TAM_NombreDealer__c,
                                                                TAM_CodigoDealer__c,
                                                                TAM_Monto_sin_IVA__c,
                                                                TAM_IncentivoPropuestoDealer__c,
                                                                TAM_EstatusVINEdoCta__c,
                                                                RecordType.Name,
                                                                TAM_Periodo__c,
                                                                TAM_Anio_Incentivo__c,
                                                                TAM_FechaFactura__c,
                                                                TAM_Movimiento__c
                                                        FROM 	TAM_DetalleEstadoCuenta__c
                                                        WHERE	TAM_VIN__c IN: setAllVinesDelMesFlotilla
                                                        AND     TAM_EstatusVINEdoCta__c =: STRING_ESTATUS_EDO_CTA_ENVIADO_A_FACTURAR]){
                                                            //Agregalo al mapa de mapEdoCuentaFlotilla
                                                            mapEdoCuentaFlotilla.put(objDetEdoCta.TAM_VIN__c, objDetEdoCta);        	
                                                        }
        return mapEdoCuentaFlotilla;
    }
    
    //Obtener Codigos de productos
    public static Map<String, TAM_ModeloCodigoProducto__c> getModeloCodProd(){
        Map<String, TAM_ModeloCodigoProducto__c> mapModeloCodigoProd = new Map<String, TAM_ModeloCodigoProducto__c>();
        for (TAM_ModeloCodigoProducto__c objModCodProd : [Select t.TAM_Modelo__c, t.TAM_Codigo__c, t.Name, t.Id 
                                                          From TAM_ModeloCodigoProducto__c t order by Name ]){
                                                              
                                                              //Agregalo al mapa de mapModeloCodigoProd
                                                              mapModeloCodigoProd.put(objModCodProd.Name, objModCodProd);
                                                          }
        return mapModeloCodigoProd;
    }
    
    //Obtener VINES de Vtas. Corporativas 
    public static Map<String, TAM_CheckOutDetalleSolicitudCompra__c> getVtaCorporativaInventario(Set<String> setVines, String strAnio, String strMes, Map<String, TAM_CalendarioToyota__c> mapCalendarioTOYOTA){
        Map<String, String> mapoNoSolVines = new Map<String, String>();
        Map<String, TAM_SolicitudesFlotillaPrograma__c> MapPaso = new Map<String, TAM_SolicitudesFlotillaPrograma__c>();
        mapVtaCorporativaDatosClienteInvent = new Map<String, TAM_SolicitudesFlotillaPrograma__c>();         
        Map<String, TAM_CheckOutDetalleSolicitudCompra__c> mapVtaCorporativaFlotillaInventario = new Map<String, TAM_CheckOutDetalleSolicitudCompra__c>();
        String strPeriodoProvision = strMes + strAnio;
        Date datFinPeriodo = mapCalendarioTOYOTA.get(strPeriodoProvision).TAM_FechaFin__c + 1;
        List<TAM_CheckOutDetalleSolicitudCompra__c>  lstVtaCorp = [ SELECT  id, TAM_VIN__c, TAM_PoliticaIncentivos__c, TAM_SolicitudFlotillaPrograma__c,TAM_SolicitudFlotillaPrograma__r.TAM_FechaCierreSolicitud__c,
                                                                            TAM_SolicitudFlotillaPrograma__r.Name, TAM_IncPropuestoPorcentaje__c, TAM_IncentivoTMEXPorcentaje__c, 
                                                                            TAM_IncDealerPorcentaje__c, TAM_IncPropuestoCash__c, TAM_IncentivoTMEXCash__c, TAM_IncDealerCash__c,
                                                                            TAM_Intercambio__c,TAM_NoDealerIntercambio__c,TAM_Historico__c 
                                                                    FROM    TAM_CheckOutDetalleSolicitudCompra__c
                                                                    WHERE   TAM_VIN__c IN: setVines
                                                                    AND     TAM_SolicitudFlotillaPrograma__c != null
                                                                    AND     TAM_EstatusDealerSolicitud__c !=: STRING_ESTATUS_RECHAZADA
                                                                    AND     TAM_EstatusDealerSolicitud__c !=: STRING_ESTATUS_PENDIENTE
                                                                    AND     TAM_EstatusEntrega__c !=: STRING_ESTATUS_RECHAZADO
                                                                    AND     (TAM_FechaCancelacion__c = null
                                                                            OR  TAM_FechaCancelacion__c >=: datFinPeriodo
                                                                            )
                                                                ];
        for (TAM_CheckOutDetalleSolicitudCompra__c objChkVin : lstVtaCorp){
            //Metelo al mapa de mapVtaCorporativaFlotillaInventario
            DateTime datTimeCierreSolicitud = objChkVin.TAM_SolicitudFlotillaPrograma__r.TAM_FechaCierreSolicitud__c.date();
            if(datTimeCierreSolicitud  < datFinPeriodo){
                mapVtaCorporativaFlotillaInventario.put(objChkVin.TAM_VIN__c, objChkVin);
                mapoNoSolVines.put(objChkVin.TAM_VIN__c, objChkVin.TAM_SolicitudFlotillaPrograma__r.Name);
            } 
        }

        //Consulta los datos de las solicitudes
        for (TAM_SolicitudesFlotillaPrograma__c objTAMSolicitudCompraFLOTILLA : [Select t.Id, 
                                                                                 t.TAM_Cliente__c, TAM_Cliente__r.Name, t.TAM_Cliente__r.TAM_GrupoCorporativo__c,  
                                                                                 t.TAM_Cliente__r.TAM_GrupoCorporativo__r.Name, t.TAM_Cliente__r.TAM_IdExternoNombre__c,
                                                                                 t.OwnerId, t.Name, t.TAM_FechaCierreSolicitud__c, 
                                                                                 t.TAM_Cliente__r.TAM_TipoPersonaProspecto__c, TAM_Cliente__r.RFC__c, TAM_Cliente__r.TAM_RFC_1__pc,
                                                                                 t.TAM_ProgramaRango__c, t.TAM_Cliente__r.TAM_ProgramaRango__r.Name, 
                                                                                 t.TAM_ProgramaRango__r.NumUnidadesMinimas__c, 
                                                                                 t.TAM_ProgramaRango__r.NumUnidadesMaximas__c, TAM_ProgramaRango__r.Name
                                                                                 From TAM_SolicitudesFlotillaPrograma__c t Where Name IN :mapoNoSolVines.Values()
                                                                                 And t.TAM_ProgramaRango__c != null ]){
                                                                                     //Metelo al mapa de mapVtaCorporativaDatosCliente
                                                                                     MapPaso.put(objTAMSolicitudCompraFLOTILLA.Name, objTAMSolicitudCompraFLOTILLA);    
                                                                                 }                                                                                
        
        //Recorre el mapa de mapoNoSolVines
        if(mapoNoSolVines != null){
            for (String sVinPaso : mapoNoSolVines.KeySet()){
                //Agrega al mapa de mapVtaCorporativaDatosCliente el vin
                if(MapPaso != null){
                    mapVtaCorporativaDatosClienteInvent.put(sVinPaso, MapPaso.get( mapoNoSolVines.get(sVinPaso) ) );      
                }
            }
        }                                                                                
        
        //Regresa el mapa de mapVtaCorporativaFlotillaInventario
        return mapVtaCorporativaFlotillaInventario;
    }
    
    //Get Datos Factura
    public static void getDatosFactura(Set<String> setVines){
        mapFacturasDetalle = new Map<String, Factura__c>  ();
        for (Factura__c objFacturaDetalle : [Select f.TAM_UUID__c, f.TAM_Folio__c, f.TAM_FechaTimbrado__c, 
                                             f.TAM_FechaFolio__c, f.Name, f.TAM_NombreReceptor__c, f.TAM_NombreEmisor__c
                                             From Factura__c f Where Name IN :setVines
                                             order by Name]){
                                                 //Agregalo al mapa de mapModeloCodigoProd
                                                 mapFacturasDetalle.put(objFacturaDetalle.Name, objFacturaDetalle);
                                             }
    }
    
    //Get Lista de Precios
    public static void getListaPrecios(Set<String> setProductos, TAM_ProvisionIncentivos__c objNewProvision){
        
        Map<String, String> mapMes = new Map<String, String>();
        mapMes.put('Enero', '1');
        mapMes.put('Febrero', '2');
        mapMes.put('Marzo', '3');
        mapMes.put('Abril', '4');
        mapMes.put('Mayo', '5');
        mapMes.put('Junio', '6');
        mapMes.put('Julio', '7');
        mapMes.put('Agosto', '8');
        mapMes.put('Septiembre', '9');
        mapMes.put('Octubre', '10');
        mapMes.put('Noviembre', '11');
        mapMes.put('Diciembre', '12');
        
        Set<String> setProductosStdPbe = new Set<String>();
        mapListaPrecops = new Map<String, PricebookEntry>();
        
        String strMesPBE = mapMes.get(objNewProvision.TAM_MesDeProvision__c);
        String strNombreCatalogoPrecios = 'VH-' + objNewProvision.TAM_MesDeProvision__c + '-' + objNewProvision.TAM_AnioDeProvision__c;
        
        for(PricebookEntry objListaPrecios : [ SELECT Product2.IdExternoProducto__c, PrecioPublico__c, TAM_MSRP__c
                                              FROM PricebookEntry WHERE IsActive = true AND Pricebook2.Name =:strNombreCatalogoPrecios
                                              AND Product2.IdExternoProducto__c IN :setProductos]){
                                                  //Metelos al mapa de mapListaPrecops
                                                  mapListaPrecops.put(objListaPrecios.Product2.IdExternoProducto__c, objListaPrecios);
                                              }
        
        //Ya tienes los productos con los precios actuales en base a la lista strNombreCatalogoPrecios
        for (String sIdExterno : setProductos){
            //Ve si no existe sIdExterno en mapListaPrecops
            if (!mapListaPrecops.containsKey(sIdExterno)){
                setProductosStdPbe.add(sIdExterno);
            }
        }
        
        //Ya tienes los productos de la lista de precios que faltaron setProductosStdPbe
        if(!setProductosStdPbe.isEmpty()){
            for(PricebookEntry objListaPrecios : [ SELECT Product2.IdExternoProducto__c, PrecioPublico__c, TAM_MSRP__c
                                                FROM PricebookEntry WHERE IsActive = true AND Pricebook2.Name =: STRING_STANDARPRICEBOOK_NAME
                                                AND Product2.IdExternoProducto__c IN :setProductosStdPbe]){
                                                    //Metelos al mapa de mapListaPrecops
                                                    mapListaPrecops.put(objListaPrecios.Product2.IdExternoProducto__c, objListaPrecios);
                                                }
        }
    }

    //Vines de flotilla presentes en macros anteriores
    public static List<TAM_HistoricoFlotillasVines__c> getHistoricoVinesFlotilla(){
        List<TAM_HistoricoFlotillasVines__c> lstHistorico = [SELECT Name FROM TAM_HistoricoFlotillasVines__c];
        return lstHistorico;
    }

    //Consultar Calendario TOYOTA
    public static Map<String, TAM_CalendarioToyota__c> getCalendarioTOYOTA(){
        List<TAM_CalendarioToyota__c> lstCalendario = [ SELECT  TAM_Periodo__c, TAM_Anio__c, TAM_FechaInicio__c, TAM_FechaFin__c
                                                        FROM    TAM_CalendarioToyota__c];
        Map<String, TAM_CalendarioToyota__c> mapCalendarioTOYOTA = new Map<String, TAM_CalendarioToyota__c>();
        for(TAM_CalendarioToyota__c objCalendario : lstCalendario){
            String strPeriodo = objCalendario.TAM_Periodo__c + objCalendario.TAM_Anio__c;
            mapCalendarioTOYOTA.put(strPeriodo, objCalendario);
        }
        return mapCalendarioTOYOTA;
    }

    //Obtener vines del modulo Auto Demo
    public static List<SolicitudAutoDemo__c> getDemos(Set<String> setAllVinesDelMes){
        List<SolicitudAutoDemo__c> lstDemos = [ SELECT  VIN__c, VIN__r.Name
                                                FROM    SolicitudAutoDemo__c 
                                                WHERE   VIN__r.Name IN: setAllVinesDelMes 
                                                AND     Estatus__c !=: STRING_ESTATUS_ALTA_RECHAZADA_TMEX
                                                AND     Estatus__c !=: STRING_ESTATUS_ALTA_RECHAZADA_TFS];
        return lstDemos;
    }

    
    /*******************************************************************************************************************************************************************/
    
    //Set Flotillas
    public static void setFlotillaDetalle(String recordId, TAM_ProvisionIncentivos__c objNewProvision, Map<String, List<TAM_DetallePoliticaJunction__c>> mapIncentivosFlotilla,
                                          Set<String> setAllVinesDelMesFlotilla, Map<String, List<Movimiento__c>> mapMovimientosFlotilla, Map<String, TAM_SolicitudExpecionIncentivo__c> mapExcepcionesFlotilla,
                                          Map<String, TAM_DetalleEstadoCuenta__c> mapEdoCuentaFlotilla, List<Movimiento__c> lstMovFlotilla, Map<String, TAM_ModeloCodigoProducto__c> mapModeloCodigoProd,
                                          String RecordTypeId_Flotilla,  Map<String, TAM_CheckOutDetalleSolicitudCompra__c> mapVtaCorporativaFlotillaInventario,
                                          Map<String, List<TAM_DetallePoliticaJunction__c>> mapIncentivosRetail, List<TAM_HistoricoFlotillasVines__c> lstHistoricoFlotillas,
                                          String strAnio, String strMes, Map<String, TAM_CalendarioToyota__c> mapCalendarioTOYOTA, Set<String> setReversas,List<SolicitudAutoDemo__c> lstDemos){                          
                                              
        String strPeriodoProvision = strMes + strAnio;
        Date datFinPeriodo = mapCalendarioTOYOTA.get(strPeriodoProvision).TAM_FechaFin__c + 1;
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleFlotillaConReversa = new List<TAM_DetalleProvisionIncentivo__c>();
        List<Movimiento__c> lstMovRetailConReversa = new List<Movimiento__c>();
        Set<String> setVines = setAllVinesDelMesFlotilla;
        Date finVigenciaPoliticaRetail;
        boolean x = true;
        List<TAM_VINDescartadoProvision__c> lstDescartados = new List<TAM_VINDescartadoProvision__c>();
        
        //obtener fecha fin de vigencia de la politica Retail
        for(List<TAM_DetallePoliticaJunction__c> lstDetalle: mapIncentivosRetail.values()){
            if(x && lstDetalle[0].TAM_PoliticaIncentivos__r.TAM_FinVigencia__c != null){
                finVigenciaPoliticaRetail = lstDetalle[0].TAM_PoliticaIncentivos__r.TAM_FinVigencia__c;
            }
            x=false;
        }
        
        //Obtener Historico de Provisiones Anteriores - 2 meses
        Integer prov_intMesAnterior;
        Integer prov_intAnioAnterior;
        Integer prov_intMesAnterior_2;
        Integer prov_intAnioAnterior_2;
        
        //Mes Anterior
        if(strMes == '1'){
            prov_intMesAnterior = 12;
            prov_intAnioAnterior = Integer.valueOf(strAnio) -1;
        } else {
            prov_intMesAnterior = Integer.valueOf(strMes) -1;
            prov_intAnioAnterior = Integer.valueOf(strAnio);
        }
        //Mes ante-aterior
            if(prov_intMesAnterior == 1){
            prov_intMesAnterior_2 = 12;
            prov_intAnioAnterior_2 = prov_intAnioAnterior -1;
        } else {
            prov_intMesAnterior_2 = prov_intMesAnterior -1;
            prov_intAnioAnterior_2 = prov_intAnioAnterior;
        }
        
        Map<Integer, String> mapMesPorNum = new Map<Integer, String>();
        mapMesPorNum.put(1,'Enero');
        mapMesPorNum.put(2,'Febrero');
        mapMesPorNum.put(3,'Marzo');
        mapMesPorNum.put(4,'Abril');
        mapMesPorNum.put(5,'Mayo'); 
        mapMesPorNum.put(6,'Junio');
        mapMesPorNum.put(7,'Julio');
        mapMesPorNum.put(8,'Agosto');
        mapMesPorNum.put(9,'Septiembre');
        mapMesPorNum.put(10,'Octubre');
        mapMesPorNum.put(11,'Noviembre');
        mapMesPorNum.put(12,'Diciembre');
        
        String strMesAnterior = mapMesPorNum.get(prov_intMesAnterior);
        String strMesAnterior_2 = mapMesPorNum.get(prov_intMesAnterior_2);
        
        String strAnioAnterior = String.valueOf(prov_intAnioAnterior);
        String strAnioAnterior_2 = String.valueOf(prov_intAnioAnterior_2);

        //Obtener Provisiones previas en caso de aplicar, de los vines con excepción.
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [  SELECT  TAM_VIN__r.Name,TAM_VIN__r.Id,TAM_IncentivoTMEX_Efectivo__c,TAM_Fleet__c
                                                                        FROM    TAM_DetalleProvisionIncentivo__c
                                                                        WHERE   TAM_VIN__r.Name IN: setAllVinesDelMesFlotilla 
                                                                        AND     (RecordTypeId =: RECORDTYPEID_DETALLEINCENTIVOS_VENTACORPORATIVA OR RecordTypeId =: RECORDTYPEID_DETALLEINCENTIVOS_RETAIL)
                                                                        AND     TAM_Clasificacion__c =: STRING_CLASIFICACION_SIN_REVERSA
                                                                        AND     (  (TAM_ProvisionIncentivos__r.TAM_MesDeProvision__c =: strMesAnterior AND TAM_ProvisionIncentivos__r.TAM_AnioDeProvision__c=:strAnioAnterior)
                                                                                OR (TAM_ProvisionIncentivos__r.TAM_MesDeProvision__c =: strMesAnterior_2 AND TAM_ProvisionIncentivos__r.TAM_AnioDeProvision__c=:strAnioAnterior_2)
                                                                                )
                                                                        ];
        Map<String, TAM_DetalleProvisionIncentivo__c> mapDetalleProvision = new Map<String, TAM_DetalleProvisionIncentivo__c>();
        if(!lstDetalleProvision.isEmpty()){
            for(TAM_DetalleProvisionIncentivo__c objDetalle : lstDetalleProvision){
                TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                objDescartar.Name = objDetalle.TAM_VIN__r.Name;
                objDescartar.TAM_VIN__c = objDetalle.TAM_VIN__r.Id;
                objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_PROVISIONADO;
                objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                objDescartar.TAM_ProvisionIncentivos__c = recordId;
                lstDescartados.add(objDescartar);
                setVines.remove(objDetalle.TAM_VIN__r.Name);
            }
        }

        //Validar que contemos con incentivos definidos en la politica.
        if (mapIncentivosFlotilla != null){
            
            //Recorrer los movimientos de los VINES a validar
            for (String sVinMovPaso : mapMovimientosFlotilla.KeySet()){
                List<Movimiento__c> lObjMov = mapMovimientosFlotilla.get(sVinMovPaso);

                if(!lObjMov.isEmpty()){
                    for (Movimiento__c objMov : lObjMov){

                        //Toma los datos del VIN y crea la llave 
                        if(objMov.Year_Modelo__c != null && objMov.TAM_Serie__c != null && objMov.Modelo__r.Name != null){
                            String sVinPasoLlave = objMov.Year_Modelo__c + '-' + objMov.Modelo__r.Name; 
                            //Si no existe sVinPasoLlave en mapIncentivosFlotilla quitala de setVines
                            if (!mapIncentivosFlotilla.containsKey(sVinPasoLlave)){
                                TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                                objDescartar.Name = objMov.VIN__r.Name;
                                objDescartar.TAM_VIN__c = objMov.VIN__r.Id;
                                objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_SIN_INCENTIVO;
                                objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                                objDescartar.TAM_ProvisionIncentivos__c = recordId;
                                lstDescartados.add(objDescartar);
                                setVines.remove(objMov.VIN__r.Name);
                                break;
                            }
                        }
                    }
                }
            }
        }
            
        
        //Validar registros.
        for(String strVinMap : mapMovimientosFlotilla.keySet()){

            /**REMOVER SI ESTA REGISTRADO COMO AUTO-DEMO */
            if(!lstDemos.isEmpty() && setVines.contains(strVinMap)){
                for(SolicitudAutoDemo__c objDemo : lstDemos){
                    if(objDemo.VIN__r.Name == strVinMap){
                        TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                        objDescartar.Name = objDemo.VIN__r.Name;
                        objDescartar.TAM_VIN__c = objDemo.VIN__r.Id;
                        objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_DEMO;
                        objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                        objDescartar.TAM_ProvisionIncentivos__c = recordId;
                        lstDescartados.add(objDescartar);
                        setVines.remove(strVinMap);
                    }
                }
            }

            /**FLEET C Y N: ACORDE AL BOLETIN SI UN VIN EXCEDE 90 DIAS ENTRE SU PRIMER REPORTE DE DD Y LA FECHA DE CIERRE DE VENTAS CALENDARIO TOYOTA YA NO SE LE PAGA INCENTIVO */
            List<Movimiento__c> lstVIN_Movimientos = mapMovimientosFlotilla.get(strVinMap);
            Movimiento__c objMov = new Movimiento__c();
            Movimiento__c objPrimerMov = lstVIN_Movimientos.get(0);
            Date datFechaEnvio = objPrimerMov.Submitted_Date__c.date();
            Integer intDiasTranscurridos = datFechaEnvio.daysBetween(datFinPeriodo);
            if(intDiasTranscurridos > 90){
                TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                objDescartar.Name = objPrimerMov.VIN__r.Name;
                objDescartar.TAM_VIN__c = objPrimerMov.VIN__r.Id;
                objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_FLEET_C_90_DIAS;
                objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                objDescartar.TAM_ProvisionIncentivos__c = recordId;
                lstDescartados.add(objDescartar);
                setVines.remove(objPrimerMov.VIN__r.Name);
            }

            /**FLEET N: SI UN VIN TERMINO CON RDR EN MESES ANTERIORES NO SE LE PAGA INCENTIVO */
            String strPeriodoAnterior = String.valueOf(prov_intMesAnterior ) + String.valueOf(prov_intAnioAnterior);
            String strPeriodoAnterior_2 = String.valueOf(prov_intMesAnterior_2 ) + String.valueOf(prov_intAnioAnterior_2);
            for(Movimiento__c obj : lstVIN_Movimientos ){
	
                //OBTENER PRIMER MOVIMIENTO DEL MES DE PROVISIÓN
                if(obj.TAM_MesAnio__c == strPeriodoProvision){
                    objMov = obj;
                    break;
                }else if(obj.TAM_MesAnio__c == strPeriodoAnterior){
                    //OBTENER PRIMER MOVIMIENTO DEL MES ANTERIOR
                    objMov = obj;
                    break;
                }else if(obj.TAM_MesAnio__c == strPeriodoAnterior_2){
                    //OBTENER EL PRIMER MOVIMIENTO DEL MES ANTE-ATERIOR.
                    objMov = obj;
                    break;
                }
            }  
            if(objMov != null && objMov.Fleet__c == 'N'){
        
                //Si el primer mov es RVRSL significa que termino como RDR en meses anteriores.
                if(objMov.Trans_Type__c == 'RVRSL' && setVines.contains(strVinMap)){
                    //setReversas.add(objMov.VIN__r.Name);
                    TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                    objDescartar.Name = objMov.VIN__r.Name;
                    objDescartar.TAM_VIN__c = objMov.VIN__r.Id;
                    objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_FLEET_N_RVRSL;
                    objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                    objDescartar.TAM_ProvisionIncentivos__c = recordId;
                    lstDescartados.add(objDescartar);
                    setVines.remove(objMov.VIN__r.Name);
                }
                
                //Si inicia con RDR y tiene mas de un movimiento, implica que tiene reversas.
                if(objMov.Trans_Type__c == 'RDR' && setVines.contains(strVinMap) && lstVIN_Movimientos.size() > 1){
                    
                    //tiene mov en meses anteriores
                    if(objPrimerMov.TAM_MesAnio__c != strPeriodoProvision){
                        
                        List<Movimiento__c> lstAux = new List<Movimiento__c>();
                        
                        //Obtenemos todos los movimientos del primer mes reportado en Dealer Daily.
                        for(Movimiento__c objMovAux : lstVIN_Movimientos ){
                            if(objMovAux.TAM_MesAnio__c == objPrimerMov.TAM_MesAnio__c ){
                                lstAux.add(objMovAux);
                            }
                        }
                        if(!lstAux.isEmpty()){
                            //Obtenemos el último movimiento del primer mes de reporte.
                            Movimiento__c objMovAux = lstAux.get(lstAux.size() -1);
                            
                            //validamos si termino en venta me el mes de su primer reporte
                            if(objMovAux.Trans_Type__c == 'RDR' && setVines.contains(objMov.VIN__r.Name)){
                                //validar si tiene mas mov posteriores
                                if(objMov.VIN__r.Ultimo_Movimiento__c != objMovAux.Id){
                                    //setReversas.add(objPrimerMov.VIN__r.Name);
                                    TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                                    objDescartar.Name = objPrimerMov.VIN__r.Name;
                                    objDescartar.TAM_VIN__c = objPrimerMov.VIN__r.Id;
                                    objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_FLEET_N_RVRSL;
                                    objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                                    objDescartar.TAM_ProvisionIncentivos__c = recordId;
                                    lstDescartados.add(objDescartar);
                                    setVines.remove(objPrimerMov.VIN__r.Name);
                                }
                            }
                        }
                    }
                }
            }
            
        }

        /** VALIDACION DE REVERSAS */
        if(!setReversas.isEmpty()){
            for (String sVinPaso : setReversas){
                if (setVines.contains(sVinPaso)){
                    TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                    objDescartar.Name = sVinPaso;
                    objDescartar.TAM_VIN__c = mapMovimientosFlotilla.get(sVinPaso)[0].VIN__r.Id;
                    objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_REVERSADO;
                    objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                    objDescartar.TAM_ProvisionIncentivos__c = recordId;
                    lstDescartados.add(objDescartar);
                    setVines.remove(sVinPaso);
                }
            }
        }
  
        //Valida si el vin ya se encuentra registrado en un edo de cuenta.
        if (mapEdoCuentaFlotilla != null){
            for (String sVinPaso : mapEdoCuentaFlotilla.KeySet()){
                if (setVines.contains(sVinPaso)){
                    TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                    objDescartar.Name = sVinPaso;
                    objDescartar.TAM_VIN__c = mapMovimientosFlotilla.get(sVinPaso)[0].VIN__r.Id;
                    objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_EDO_CTA;
                    objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                    objDescartar.TAM_ProvisionIncentivos__c = recordId;
                    lstDescartados.add(objDescartar);
                    setVines.remove(sVinPaso);
                }
            }
        }

        //Validar si el vin se encuentra en un historico de flotillas - Macros proporcionadas por Finanzas.
        if (!lstHistoricoFlotillas.isEmpty()){
            for(TAM_HistoricoFlotillasVines__c objHistorico : lstHistoricoFlotillas ){
                if(setVines.contains(objHistorico.Name)){
                    TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                    objDescartar.Name = objHistorico.Name;
                    objDescartar.TAM_VIN__c = mapMovimientosFlotilla.get(objHistorico.Name)[0].VIN__r.Id;
                    objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_HISTORICO_MACROS;
                    objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                    objDescartar.TAM_ProvisionIncentivos__c = recordId;
                    lstDescartados.add(objDescartar);
                    setVines.remove(objHistorico.Name);
                }
            }
        }
            
        //Un set para validar los vines finales
        Set<String> setVinesPaso = new Set<String>();
        if (setVines != null){
            //Ve si alguno de los setVines esta en el mapa de 
            if(mapVtaCorporativaFlotillaInventario != null){
                for(String sVinPaso : mapVtaCorporativaFlotillaInventario.KeySet()){
                    setVinesPaso.add(sVinPaso); 
                }
            }
        }
            
        //Recorre la lista de setVines y ve si existen en la lista de setVinesPaso
        for(String sVinFinal : setVines){
            if (!setVinesPaso.contains(sVinFinal)){
                TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                objDescartar.Name = sVinFinal;
                objDescartar.TAM_VIN__c = mapMovimientosFlotilla.get(sVinFinal)[0].VIN__r.Id;
                objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_SIN_VC;
                objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                objDescartar.TAM_ProvisionIncentivos__c = recordId;
                lstDescartados.add(objDescartar);
                setVines.remove(sVinFinal);       
            }		
        }
            
        //Llama al metodo getDatosFactura para obtener las facturas si es que existe algo ahi
        getDatosFactura(setVines);
        Set<String> setItExtProd = new Set<String>();
        //Recorre la lista finales de vines
        for(Movimiento__c objMovimiento : lstMovFlotilla){
            //Ve si exite en la lista de setVines
            if (setVines.contains(objMovimiento.VIN__r.Name))
                if (objMovimiento.Modelo__r.IdExternoProducto__c != null)
                setItExtProd.add(objMovimiento.Modelo__r.IdExternoProducto__c);
        }
            
        //Llama al metodo de getListaPrecios
        getListaPrecios(setItExtProd, objNewProvision);
        
        //Desliega los vines finales
        List<Movimiento__c> lstMovFlotillaFinal = new List<Movimiento__c>();
        Integer intAnioAnterior;
        Integer intMesAnterior;
        Integer intMesAnterior_2;
        Integer intAnioAnterior_2;
        
        //Mes Anterior
        if(strMes == '1'){
            intMesAnterior = 12;
            intAnioAnterior = Integer.valueOf(strAnio) -1;
        } else {
            intMesAnterior = Integer.valueOf(strMes) -1;
            intAnioAnterior = Integer.valueOf(strAnio);
        }
        //Mes ante-aterior
        if(intMesAnterior == 1){
            intMesAnterior_2 = 12;
            intAnioAnterior_2 = intAnioAnterior -1;
        } else {
            intMesAnterior_2 = intMesAnterior -1;
            intAnioAnterior_2 = intAnioAnterior;
        }
        String strMesAnioProv_1 = strMes + strAnio;
        String strMesAnioProv_2 = String.valueOf(intMesAnterior) + String.valueOf(intAnioAnterior);
        String strMesAnioProv_3 = String.valueOf(intMesAnterior_2) + String.valueOf(intAnioAnterior_2);
        Set<String> setVINAUX = new Set<String>();

        //validar ultimo movimiento
        for(Movimiento__c objMovimiento : lstMovFlotilla){
            if (objMovimiento.id == objMovimiento.VIN__r.Ultimo_Movimiento__c){
                if(objMovimiento.TAM_MesAnio__c == strMesAnioProv_1 || objMovimiento.TAM_MesAnio__c == strMesAnioProv_2 || objMovimiento.TAM_MesAnio__c == strMesAnioProv_3){
                    lstMovFlotillaFinal.add(objMovimiento);
                    setVINAUX.add(objMovimiento.VIN__r.Name);
                } else if(!setVINAUX.contains(objMovimiento.VIN__r.Name)){
                    List<Movimiento__c> lstAUX = new List<Movimiento__c>();
                    for(Movimiento__c objMov : mapMovimientosFlotilla.get(objMovimiento.VIN__r.Name)){
                        if(objMov.TAM_MesAnio__c == strMesAnioProv_1 || objMov.TAM_MesAnio__c == strMesAnioProv_2 || objMov.TAM_MesAnio__c == strMesAnioProv_3){
                            lstAUX.add(objMov);
                        }
                    }
                    if(!lstAUX.isEmpty()){
                        lstMovFlotillaFinal.add(lstAUX[lstAUX.size() -1]);
                        setVINAUX.add(lstAUX[lstAUX.size() -1].VIN__r.Name);
                    }
                }
            }
        }
        
        //Recorre la lista finales de vines
        for(Movimiento__c objMovimiento : lstMovFlotillaFinal){
                //Validar factura acorde a regla definida por Hector Omar Dominguez
                List<String> lstFacturaDummy = new List<String>();
                lstFacturaDummy.add(STRING_FACTURA_DDD);
                lstFacturaDummy.add(STRING_FACTURA_DDDD);
                lstFacturaDummy.add(STRING_FACTURA_DDDDD);
                lstFacturaDummy.add(STRING_FACTURA_DDDDDDDDD);
                lstFacturaDummy.add(STRING_FACTURA_DDDDDDDDDD);
                lstFacturaDummy.add(STRING_FACTURA_AUTODEMO);
                lstFacturaDummy.add(STRING_FACTURA_A0000);
                lstFacturaDummy.add(STRING_FACTURA_A000000000);
                lstFacturaDummy.add(STRING_FACTURA_AAGS);
                lstFacturaDummy.add(STRING_FACTURA_FFFF);
                lstFacturaDummy.add(STRING_FACTURA_FFFFF);
                lstFacturaDummy.add(STRING_FACTURA_FFFFFF);
                lstFacturaDummy.add(STRING_FACTURA_FFFFFFF);
                lstFacturaDummy.add(STRING_FACTURA_FLT);
                lstFacturaDummy.add(STRING_FACTURA_FNC);
                lstFacturaDummy.add(STRING_FACTURA_FNCT);
                lstFacturaDummy.add(STRING_FACTURA_SF);
                lstFacturaDummy.add(STRING_FACTURA_VD);
                lstFacturaDummy.add(STRING_FACTURA_0);
                lstFacturaDummy.add(STRING_FACTURA_00);
                lstFacturaDummy.add(STRING_FACTURA_000);
                lstFacturaDummy.add(STRING_FACTURA_0000);
                lstFacturaDummy.add(STRING_FACTURA_00000);
                                                    
                //Validar si el dealer cargo XML del VIN
                Boolean boolFacturaCargada = true;
                if(lstFacturaDummy.contains(objMovimiento.Factura__c)){
                    List<Factura__c> lstFactura = [ SELECT  Id,VIN__c,TAM_FechaTimbrado__c,VIN__r.Name 
                                                    FROM    Factura__c 
                                                    WHERE   VIN__r.Name =:objMovimiento.VIN__r.Name
                                                    AND     Distribuidor__r.Codigo_Distribuidor__c =:objMovimiento.Distribuidor__r.Codigo_Distribuidor__c
                                                    AND     TAM_UUID__c != null
                                                    ORDER BY TAM_FechaTimbrado__c DESC];
                    if(lstFactura.isEmpty()){
                        boolFacturaCargada = false;
                        TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                        objDescartar.Name = objMovimiento.VIN__r.Name;
                        objDescartar.TAM_VIN__c = objMovimiento.VIN__r.Id;
                        objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_SIN_FACTURA;
                        objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                        objDescartar.TAM_ProvisionIncentivos__c = recordId;
                        lstDescartados.add(objDescartar);
                        
                    }

                }
                if(boolFacturaCargada){
                    //Ve si exite en la lista de setVines
                    if (setVines.contains(objMovimiento.VIN__r.Name) && objMovimiento.Trans_Type__c == STRING_TIPO_MOVIMIENTO_RDR){

                        //Toma los datos del VIN y crea la llave 
                        String sVinPasoLlave = objMovimiento.Year_Modelo__c + '-'+ objMovimiento.Modelo__r.Name; 
                        
                        //Crea el objeto del tipo TAM_DetalleProvisionIncentivo__c
                        TAM_DetalleProvisionIncentivo__c objDetalleProvision =  new TAM_DetalleProvisionIncentivo__c();
                        TAM_ModeloCodigoProducto__c objPasoModCodProd = mapModeloCodigoProd.containsKey(objMovimiento.Modelo__r.Name) ? mapModeloCodigoProd.get(objMovimiento.Modelo__r.Name) : new TAM_ModeloCodigoProducto__c();
                        Factura__c objFacturaDetalle = mapFacturasDetalle.containsKey(objMovimiento.VIN__r.Name) ? mapFacturasDetalle.get(objMovimiento.VIN__r.Name) : new Factura__c();
                        PricebookEntry objListaPrecios = mapListaPrecops.containsKey(objMovimiento.Modelo__r.IdExternoProducto__c) ? mapListaPrecops.get(objMovimiento.Modelo__r.IdExternoProducto__c) : new PricebookEntry();
                        List<TAM_DetallePoliticaJunction__c> lObjPoliticaIncentivoFlot = mapIncentivosFlotilla.containsKey(sVinPasoLlave) ? mapIncentivosFlotilla.get(sVinPasoLlave) : new List<TAM_DetallePoliticaJunction__c>();
                        
                        //Obtener datos desde el CheckOut
                        TAM_CheckOutDetalleSolicitudCompra__c objCheckOut = new TAM_CheckOutDetalleSolicitudCompra__c();
                        
                        if(objMovimiento.VIN__r.Name != null && (mapVtaCorporativaFlotillaInventario.containsKey(objMovimiento.VIN__r.Name))){
                            String strVINMovimiento = objMovimiento.VIN__r.Name;
                            
                            TAM_CheckOutDetalleSolicitudCompra__c objCheckOut_AUX = [SELECT 	TAM_IncentivoTMEXCash__c, 
                                                                                                TAM_IncentivoTMEXPorcentaje__c, 
                                                                                                TAM_IncPropuestoPorcentaje__c,
                                                                                                TAM_IncPropuestoCash__c,
                                                                                                TAM_PoliticaIncentivos__c,
                                                                                                TAM_SolicitudFlotillaPrograma__r.TAM_Cliente__r.Name,
                                                                                                TAM_SolicitudFlotillaPrograma__r.TAM_ProgramaRango__r.Name,
                                                                                                TAM_Historico__c,
                                                                                                TAM_SolicitudFlotillaPrograma__r.TAM_FechaCierreSolicitud__c
                                                                                        FROM 	TAM_CheckOutDetalleSolicitudCompra__c
                                                                                        WHERE 	TAM_VIN__c =: strVINMovimiento
                                                                                        AND     TAM_SolicitudFlotillaPrograma__c != null
                                                                                        AND     TAM_EstatusDealerSolicitud__c !=: STRING_ESTATUS_RECHAZADA
                                                                                        AND     TAM_EstatusDealerSolicitud__c !=: STRING_ESTATUS_PENDIENTE
                                                                                        AND     TAM_EstatusEntrega__c !=: STRING_ESTATUS_RECHAZADO
                                                                                        AND     (TAM_FechaCancelacion__c = null
                                                                                                    OR  TAM_FechaCancelacion__c >=: datFinPeriodo
                                                                                                )
                                                                                        ORDER BY TAM_SolicitudFlotillaPrograma__r.TAM_FechaCierreSolicitud__c DESC
                                                                                        LIMIT 1];
                            DateTime datTimeCierreSolicitud = objCheckOut_AUX.TAM_SolicitudFlotillaPrograma__r.TAM_FechaCierreSolicitud__c.date();
                            if(datTimeCierreSolicitud  < datFinPeriodo){
                                objCheckOut = objCheckOut_AUX;
                            }
                        }
                            
                        //Inicializa los campos
                        if(objCheckOut.TAM_PoliticaIncentivos__c != null ){
                            /*CÓD. DEALER*/			objDetalleProvision.TAM_CodigoDealer__c = objMovimiento.Distribuidor__r.Codigo_Distribuidor__c;
                            /*NOM. DEALER*/			objDetalleProvision.TAM_NombreDealer__c = objMovimiento.Distribuidor__r.Name;
                            /*TIPO DE MOVIMIENTO*/	objDetalleProvision.TAM_TipoMovimiento__c = objMovimiento.Trans_Type__c;
                            /*AÑO MODELO*/			objDetalleProvision.TAM_AnioModelo__c = objMovimiento.Year_Modelo__c;
                            /*MODELO*/				objDetalleProvision.TAM_Modelo__c = objMovimiento.Modelo__r.Name;
                            /*SERIE*/					objDetalleProvision.TAM_Serie__c = objMovimiento.TAM_Serie__c;
                            /*VERSIÓN*/				objDetalleProvision.TAM_Version__c = objMovimiento.Modelo__r.NombreVersion__c;
                            /*FECHA DE REG. EN DD*/	objDetalleProvision.TAM_FechaEnvio__c = String.valueOf(objMovimiento.Submitted_Date__c);
                            /*CÓD. VENTA*/			objDetalleProvision.TAM_CodigoVenta__c = objMovimiento.Sale_Code__c;
                            /*NOMBRE PROPIETARIO*/	objDetalleProvision.TAM_FirstName__c = objMovimiento.First_Name__c;
                            /*APELLIDO PROPIETARIO*/	objDetalleProvision.TAM_LastName__c = objMovimiento.Last_Name__c;
                            /*FACTURA*/ 				objDetalleProvision.TAM_Factura__c = objFacturaDetalle.TAM_Folio__c != null ? objFacturaDetalle.TAM_Folio__c : '';
                            /*NOMBRE DE CLIENTE FACTURA*/ objDetalleProvision.TAM_NombreClienteFactura__c = objFacturaDetalle.TAM_NombreReceptor__c != null ? objFacturaDetalle.TAM_NombreReceptor__c : '';
                            /*CÓDIGO CONTABLE*/ 		objDetalleProvision.TAM_CodigoContable__c = objPasoModCodProd.TAM_Codigo__c != null ? objPasoModCodProd.TAM_Codigo__c : '';
                            /*VIN*/					objDetalleProvision.TAM_VIN__c = objMovimiento.VIN__c;
                            /*PRECIO AL PUBLICO*/ 	objDetalleProvision.TAM_PrecioVehiculo__c = objListaPrecios.TAM_MSRP__c;
                            /*PROVISIONAR*/     objDetalleProvision.TAM_ProvicionarEfectivo__c = true;
                                /*TRANSMITIR */     objDetalleProvision.TAM_TransmitirDealer__c = true;				

                                
                            /*********************** CheckOut ***********************************/
                            if( objCheckOut != null && objCheckOut.TAM_PoliticaIncentivos__c != null){
                                /*HISTORICO */                      objDetalleProvision.TAM_HistoricoCheckOut__c = objCheckOut.TAM_Historico__c;
                                /*POLÍTICA DE INCENTIVOS*/          objDetalleProvision.TAM_PoliticaIncentivos__c = objCheckOut.TAM_PoliticaIncentivos__c;
                                /*PROGRAMA RANGO*/ 				    objDetalleProvision.TAM_TipoProgramaRango__c = objCheckOut.TAM_SolicitudFlotillaPrograma__r.TAM_ProgramaRango__r.Name;
                                /*NOMBRE DE CLIENTE CORPORATIVO*/   objDetalleProvision.TAM_NombreClienteCRM__c = objCheckOut.TAM_SolicitudFlotillaPrograma__r.TAM_Cliente__r.Name;

                                //Efectivo
                                if(objCheckOut.TAM_IncPropuestoCash__c != 0 && objCheckOut.TAM_IncPropuestoCash__c != null){
                                    /**INCENTIVO PROPUESTO DTM */     objDetalleProvision.TAM_IncPropuestoCash__c = objCheckOut.TAM_IncPropuestoCash__c;
                                    /**INCENTIVO DTM SIN IVA */       objDetalleProvision.TAM_IncentivoProvisionado__c = objCheckOut.TAM_IncPropuestoCash__c /1.16;
                                    /**INCENTIVO TMEX CON IVA */      objDetalleProvision.TAM_IncTMEXCash__c = objCheckOut.TAM_IncentivoTMEXCash__c;
                                    /**INCENTIVO TMEX SIN IVA */      objDetalleProvision.TAM_IncentivoTMEX_Efectivo__c = objDetalleProvision.TAM_IncTMEXCash__c /1.16;
                                }
                                //Porcentaje
                                if(objCheckOut.TAM_IncPropuestoPorcentaje__c != 0 && objCheckOut.TAM_IncPropuestoPorcentaje__c != null){
                                    /**INCENTIVO PROPUESTO DTM */     objDetalleProvision.TAM_DescuentoAutorizadoDTM__c = objCheckOut.TAM_IncPropuestoPorcentaje__c;
                                                                    objDetalleProvision.TAM_DescuentoAutorizadoDtmTxt__c = String.valueOf(objCheckOut.TAM_IncPropuestoPorcentaje__c);
                                    /**INCENTIVO DTM SIN IVA */       objDetalleProvision.TAM_IncentivoProvisionado__c = (objListaPrecios.TAM_MSRP__c * (objDetalleProvision.TAM_DescuentoAutorizadoDTM__c/100))/1.16;
                                    /**INCENTIVO TMEX  IVA */         objDetalleProvision.TAM_PorcentParticipacionTMEX__c = objCheckOut.TAM_IncentivoTMEXPorcentaje__c;
                                                                    objDetalleProvision.TAM_ParticipacionTmexTxt__c = String.valueOf(objDetalleProvision.TAM_PorcentParticipacionTMEX__c);
                                    /**MONTO TMEX SIN IVA */          objDetalleProvision.TAM_IncentivoTMEX_Efectivo__c = (objListaPrecios.TAM_MSRP__c * (objDetalleProvision.TAM_PorcentParticipacionTMEX__c/100))/1.16;
                                }
                            }
                            /**********************************************************/
                            /*Fleet*/			objDetalleProvision.TAM_Fleet__c = objMovimiento.Fleet__c;
                            /*Provisión*/ 		objDetalleProvision.TAM_ProvisionIncentivos__c = recordId;
                            /*Clasificación*/	objDetalleProvision.TAM_Clasificacion__c = STRING_CLASIFICACION_SIN_REVERSA;
                            /*Name	*/			objDetalleProvision.Name = objMovimiento.VIN__r.Name +'-'+ objMovimiento.TAM_Serie__c +'-'+ objMovimiento.Modelo__r.Name +'-'+objMovimiento.Year_Modelo__c +'-'+String.valueOf(objMovimiento.VIN__r.Ultimo_Movimiento__r.Submitted_Date__c);
                            /*Tipo Registro*/	objDetalleProvision.RecordTypeId = RecordTypeId_Flotilla;
                            /*TIPO*/			objDetalleProvision.TAM_Tipo__c = STRING_TIPO_VENTACORPORATIVA;
                            /*Id Externo	*/	objDetalleProvision.TAM_IdExterno__c = objMovimiento.VIN__r.Name +'-'+ objMovimiento.TAM_Serie__c +'-'+ objMovimiento.Modelo__r.Name +'-'+objMovimiento.Year_Modelo__c +'-'+ String.valueOf(objMovimiento.VIN__r.Ultimo_Movimiento__r.Submitted_Date__c) +'-'+ recordId;
                            /**Fin Vigencia Politica retail */ objDetalleProvision.TAM_FinVigPoliticaRetail_AUX__c = finVigenciaPoliticaRetail;

                            //Agregalo a la lista de lstDetalleFlotillaConReversa
                            lstDetalleFlotillaConReversa.add(objDetalleProvision);
                        } else {
                            //No cuenta con politica de incentivo dentro del checkOut
                            TAM_VINDescartadoProvision__c objDescartar = new TAM_VINDescartadoProvision__c();
                            objDescartar.Name = objMovimiento.VIN__r.Name;
                            objDescartar.TAM_VIN__c = objMovimiento.VIN__r.Id;
                            objDescartar.TAM_MotivoDescarte__c = STRING_MOTIVO_DESCARTE_SIN_INCENTIVO;
                            objDescartar.Tipo__c = STRING_TIPO_VENTA_CORPORATIVA;
                            objDescartar.TAM_ProvisionIncentivos__c = recordId;
                            lstDescartados.add(objDescartar);
                        }
                    }
                }
            }//fin del for para lstMovFlotilla
            
            //Guardado de datos
            try {

                //Crea el reg en la base de datos
                Database.insert(lstDescartados);
                List<Database.UpsertResult> dtUpsrv = Database.upsert(lstDetalleFlotillaConReversa, TAM_DetalleProvisionIncentivo__c.TAM_IdExterno__c, false);			
                for (Database.UpsertResult objDtSvr : dtUpsrv){
                    if(!objDtSvr.isSuccess())
                        System.debug('EN setFlotillaDetalle Error a la hora de crear los reg en TAM_DetalleProvisionIncentivo: ' + objDtSvr.getErrors()[0].getMessage());
                    if(objDtSvr.isSuccess())
                        System.debug('EN setFlotillaDetalle los datos del reg se actualizaron con exito ID: ' + objDtSvr.getId());									
                }
            } catch (DmlException e) {
                System.debug(e.getMessage());
            } 
        }
    
    //Excepciones
    public static void setExcepcionVtaCorp(String recordId, Map<String, TAM_DetalleEstadoCuenta__c> mapExcepcionesFlotilla, List<Movimiento__c> lstMovimientosFlotillas, String RecordTypeId_Excepcion, Map<String, TAM_ModeloCodigoProducto__c> mapModeloCodigoProd){
        DateTime datFechaUltimaProv = getFechaUltimaProvision();
        DateTime datFechaHoraActual = datetime.now();
        if(mapExcepcionesFlotilla != null){
            List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvisionExcepciones = new List<TAM_DetalleProvisionIncentivo__c>();
            Set<String> setVIN =  new Set<String>();
            for(TAM_DetalleEstadoCuenta__c objExcepcionVta : mapExcepcionesFlotilla.values()){
                if(objExcepcionVta.RecordTypeId == RECORDTYPEID_DETALLEEDOCTA_FLOTILLA){
                    setVIN.add(objExcepcionVta.TAM_VIN__c);
                }
            }

            //Obtener movimientos de vines con excepción
            List<Movimiento__c> lstExcepciones = [SELECT  Id,
                                                        VIN__r.Name,
                                                       VIN__r.Id,
                                                       VIN__r.Total_de_Movimientos_Reversa__c,
                                                       Modelo__r.NombreVersion__c,
                                                       Modelo__r.Name,
                                                       Modelo__r.IdExternoProducto__c,
                                                       TAM_Serie__c, 
                                                       Year_Modelo__c,
                                                       Sale_Code__c,
                                                       Distribuidor__r.Name,
                                                       Distribuidor__r.Codigo_Distribuidor__c,
                                                       First_Name__c,
                                                       Last_Name__c,
                                                       NombreCliente__c,
                                                       Submitted_Date__c,
                                                       Trans_Type__c,
                                                       Sale_Date__c,
                                                       Factura__c,
                                                       Fleet__c,
                                                       Year__c,
                                                       Month__c,
                                                       VIN__r.Ultimo_Movimiento__c,
                                                       VIN__r.Ultimo_Movimiento__r.Trans_Type__c,
                                                       VIN__r.Ultimo_Movimiento__r.NombreCliente__c,
                                                       VIN__r.Ultimo_Movimiento__r.Submitted_Date__c,
                                                       VIN__r.Ultimo_Movimiento__r.Sale_Date__c
                                                       FROM    Movimiento__c
                                                       WHERE   VIN__r.Name IN: setVIN];    

            //Obtener detalle de edo cta de las excepciones autorizadas por finanzas.
            List<TAM_DetalleEstadoCuenta__c> lstDetalleCta = [  SELECT  Id, TAM_Monto_sin_IVA__c, TAM_VIN__c,TAM_IncentivoPropuestoDealer__c
                                                                FROM    TAM_DetalleEstadoCuenta__c
                                                                WHERE   TAM_VIN__c IN: setVIN
                                                                AND     TAM_Movimiento__c =: STRING_EXCEPCION
                                                                AND     TAM_Estatus_Finanzas__c =: STRING_ESTATUS_FINANZAS_PAGO_AUTORIZADO_TMEX
                                                                AND     TAM_Fecha_Pago_Autorizado_TMEX__c >=: datFechaUltimaProv
                                                                AND     TAM_Fecha_Pago_Autorizado_TMEX__c <=:datFechaHoraActual];

            Map<String, TAM_DetalleEstadoCuenta__c> mapDetalleCtaVC = new Map<String, TAM_DetalleEstadoCuenta__c>();
            if(!lstDetalleCta.isEmpty()){
                for(TAM_DetalleEstadoCuenta__c objDetalle : lstDetalleCta){
                    mapDetalleCtaVC.put(objDetalle.TAM_VIN__c, objDetalle);
                }
            }

            //Obtener Provisiones previas en caso de aplicar, de los vines con excepción.
            List<TAM_DetalleProvisionIncentivo__c> lstDetalleProvision = [  SELECT  TAM_VIN__r.Name,TAM_VIN__r.Id,TAM_IncentivoTMEX_Efectivo__c
                                                                            FROM    TAM_DetalleProvisionIncentivo__c
                                                                            WHERE   TAM_VIN__r.Name IN: setVIN 
                                                                            AND     (RecordTypeId =: RECORDTYPEID_DETALLEINCENTIVOS_VENTACORPORATIVA OR RecordTypeId =: RECORDTYPEID_DETALLEINCENTIVOS_RETAIL)
                                                                            AND     TAM_Clasificacion__c =: STRING_CLASIFICACION_SIN_REVERSA];
            Map<String, TAM_DetalleProvisionIncentivo__c> mapDetalleProvisionVC = new Map<String, TAM_DetalleProvisionIncentivo__c>();
            if(!lstDetalleProvision.isEmpty()){
                for(TAM_DetalleProvisionIncentivo__c objDetalle : lstDetalleProvision){
                    mapDetalleProvisionVC.put(objDetalle.TAM_VIN__r.Name, objDetalle);
                }
            }


            //Llenado de información
            if(!lstExcepciones.isEmpty()){
                for(Movimiento__c objMovimiento : lstExcepciones){


                    //Validar variación de incentivo
                    Double dblVarianza = 0.0;
                    if(mapDetalleProvisionVC.containsKey(objMovimiento.VIN__r.Name) && mapDetalleCtaVC.containsKey(objMovimiento.VIN__r.Name)){
                        dblVarianza = mapDetalleCtaVC.get(objMovimiento.VIN__r.Name).TAM_IncentivoPropuestoDealer__c - mapDetalleProvisionVC.get(objMovimiento.VIN__r.Name).TAM_IncentivoTMEX_Efectivo__c;
                    } else if(!mapDetalleProvisionVC.containsKey(objMovimiento.VIN__r.Name) && mapDetalleCtaVC.containsKey(objMovimiento.VIN__r.Name)){
                        dblVarianza = mapDetalleCtaVC.get(objMovimiento.VIN__r.Name).TAM_IncentivoPropuestoDealer__c;
                    }
                    
                    if(dblVarianza != 0){
                        if(objMovimiento.VIN__r.Ultimo_Movimiento__c == objMovimiento.Id){

                            TAM_DetalleProvisionIncentivo__c objDetalleProvision =  new TAM_DetalleProvisionIncentivo__c();
                            TAM_ModeloCodigoProducto__c objPasoModCodProd = mapModeloCodigoProd.containsKey(objMovimiento.Modelo__r.Name) ? mapModeloCodigoProd.get(objMovimiento.Modelo__r.Name) : new TAM_ModeloCodigoProducto__c();

                            /*VIN*/				objDetalleProvision.TAM_VIN__c = objMovimiento.VIN__c;
                            /*CÓD. DEALER*/		objDetalleProvision.TAM_CodigoDealer__c = objMovimiento.Distribuidor__r.Codigo_Distribuidor__c;
                            /*NOM. DEALER*/		objDetalleProvision.TAM_NombreDealer__c = objMovimiento.Distribuidor__r.Name;
                            /*AÑO MODELO*/		objDetalleProvision.TAM_AnioModelo__c = objMovimiento.Year_Modelo__c;
                            /*MODELO*/			objDetalleProvision.TAM_Modelo__c = objMovimiento.Modelo__r.Name;
                            /*SERIE*/			objDetalleProvision.TAM_Serie__c = objMovimiento.TAM_Serie__c;
                            /*VERSIÓN*/			objDetalleProvision.TAM_Version__c = objMovimiento.Modelo__r.NombreVersion__c;
                            /*FECHA ENVÍO*/		objDetalleProvision.TAM_FechaEnvio__c = String.valueOf(objMovimiento.Submitted_Date__c);
                            /*FECHA VENTA*/		objDetalleProvision.TAM_FechaVenta__c = String.valueOf(objMovimiento.Sale_Date__c);
                            /*TIPO MOV.*/		objDetalleProvision.TAM_TipoMovimiento__c = objMovimiento.Trans_Type__c;
                            /*CÓD. VENTA*/		objDetalleProvision.TAM_CodigoVenta__c = objMovimiento.Sale_Code__c;
                            /*FIRST NAME*/		objDetalleProvision.TAM_FirstName__c = objMovimiento.First_Name__c;
                            /*LAST NAME */		objDetalleProvision.TAM_LastName__c = objMovimiento.Last_Name__c;
                            /*CÓDIGO CONTABLE*/ objDetalleProvision.TAM_CodigoContable__c = objPasoModCodProd.TAM_Codigo__c != null ? objPasoModCodProd.TAM_Codigo__c : '';
                            /*PROVISIONAR*/     objDetalleProvision.TAM_ProvicionarEfectivo__c = true;
                            /*TRANSMITIR */     objDetalleProvision.TAM_TransmitirDealer__c = false;

                            /**RANGO */         objDetalleProvision.TAM_TipoProgramaRango__c = mapExcepcionesFlotilla.get(objMovimiento.VIN__r.Name).TAM_Programa_Rango__c;
                            /**Excepción */     objDetalleProvision.TAM_ExepcionIncentivo__c = mapExcepcionesFlotilla.get(objMovimiento.VIN__r.Name).TAM_SolicitudExcepcion__c;
                            /**Incentivo TMEX*/ objDetalleProvision.TAM_IncentivoTMEX_Efectivo__c = dblVarianza;
                            /**Excepción Edo */ objDetalleProvision.TAM_ExcepcionEstadoCuenta__c = mapDetalleCtaVC.get(objMovimiento.VIN__r.Name).Id;
                            /**Comentario 
                            *Dealer */          objDetalleProvision.TAM_ComentarioDealer__c = mapExcepcionesFlotilla.get(objMovimiento.VIN__r.Name).TAM_SolicitudExcepcion__r.TAM_Comentario__c;
                            
                            /*Provisión*/ 		objDetalleProvision.TAM_ProvisionIncentivos__c = recordId;
                            /*Clasificación*/	objDetalleProvision.TAM_Clasificacion__c = STRING_CLASIFICACION_EXCEPCION_VENTA_CORPORATIVA;
                            /*Name	*/			objDetalleProvision.Name = objMovimiento.VIN__r.Name +'-' + objMovimiento.Modelo__r.Name + objMovimiento.Year_Modelo__c +'-'+String.valueOf(objMovimiento.VIN__r.Ultimo_Movimiento__r.Submitted_Date__c) +'-'+ STRING_CLASIFICACION_EXCEPCION_VENTA_CORPORATIVA;
                            /*Tipo Registro*/	objDetalleProvision.RecordTypeId = RecordTypeId_Excepcion;
                            /*Id Externo	*/	objDetalleProvision.TAM_IdExterno__c = objMovimiento.VIN__r.Name +'-'+String.valueOf(objMovimiento.VIN__r.Ultimo_Movimiento__r.Submitted_Date__c) +'-' + String.valueOf(objMovimiento.VIN__r.Ultimo_Movimiento__r.Sale_Date__c)+'-'+objMovimiento.Trans_Type__c +'-'+ objMovimiento.Sale_Code__c +'-' +recordId +'-' + RecordTypeId_Excepcion +'-' + mapExcepcionesFlotilla.get(objMovimiento.VIN__r.Name).Id;
                            
                            lstDetalleProvisionExcepciones.add(objDetalleProvision);
                        }
                    }
                }
                
                //Guardar Registros
                try {
                    Database.upsert(lstDetalleProvisionExcepciones, TAM_DetalleProvisionIncentivo__c.TAM_IdExterno__c);
                } catch (DmlException e) {
                    System.debug(e.getMessage());
                }
            }
        }
    }

    //Reversas
       /********************************* REVERSAS *********************************/
       public static Set<String> setFlotillaConReversa(String strMesProvision, String strAnioProvision, String recordId, Id RecordTypeId, Map<String, TAM_DetalleEstadoCuenta__c> mapEdoCuentaFlotilla, List<Movimiento__c> lstMovimientosFlotillas, Map<String, TAM_ModeloCodigoProducto__c> mapModeloCodigoProd, Map<String, TAM_CheckOutDetalleSolicitudCompra__c> mapVtaCorporativaFlotillaInventario){
        
        List<TAM_DetalleProvisionIncentivo__c> lstDetalleFlotilla_ConReversa = new List<TAM_DetalleProvisionIncentivo__c>();
        Set<String> setReversas = new Set<String>();
        Set<String> strVINES = new Set<String>();
        DateTime datFechaUltimaProv = getFechaUltimaProvision();
        DateTime datFechaHoraActual = datetime.now();
        Integer intMesAnterior;
        Integer intAnioAnterior;
        Integer intMesAnterior_2;
        Integer intAnioAnterior_2;
        
        //Mes Anterior
        if(strMesProvision == '1'){
            intMesAnterior = 12;
            intAnioAnterior = Integer.valueOf(strAnioProvision) -1;
        } else {
            intMesAnterior = Integer.valueOf(strMesProvision) -1;
            intAnioAnterior = Integer.valueOf(strAnioProvision);
        }
        //Mes ante-aterior
         if(intMesAnterior == 1){
            intMesAnterior_2 = 12;
            intAnioAnterior_2 = intAnioAnterior -1;
        } else {
            intMesAnterior_2 = intMesAnterior -1;
            intAnioAnterior_2 = intAnioAnterior;
        }
        
        String strMesAnioProv_1 = strMesProvision + strAnioProvision;
        String strMesAnioProv_2 = String.valueOf(intMesAnterior) + String.valueOf(intAnioAnterior);
        String strMesAnioProv_3 = String.valueOf(intMesAnterior_2) + String.valueOf(intAnioAnterior_2);

        Map<String, String> mapMes = new Map<String, String>();
        mapMes.put('ENERO', '1');
        mapMes.put('FEBRERO', '2');
        mapMes.put('MARZO', '3');
        mapMes.put('ABRIL', '4');
        mapMes.put('MAYO', '5'); 
        mapMes.put('JUNIO', '6');
        mapMes.put('JULIO', '7');
        mapMes.put('AGOSTO', '8');
        mapMes.put('SEPTIEMBRE', '9');
        mapMes.put('OCTUBRE', '10');
        mapMes.put('NOVIEMBRE', '11');
        mapMes.put('DICIEMBRE', '12');

        Map<String, String> mapMesPorNum = new Map<String, String>();
        mapMesPorNum.put('1','ENERO');
        mapMesPorNum.put('2','FEBRERO');
        mapMesPorNum.put('3','MARZO');
        mapMesPorNum.put('4','ABRIL');
        mapMesPorNum.put('5','MAYO'); 
        mapMesPorNum.put('6','JUNIO');
        mapMesPorNum.put('7','JULIO');
        mapMesPorNum.put('8','AGOSTO');
        mapMesPorNum.put('9','SEPTIEMBRE');
        mapMesPorNum.put('10','OCTUBRE');
        mapMesPorNum.put('11','NOVIEMBRE');
        mapMesPorNum.put('12','DICIEMBRE');

        //Set VIN's
        Set<String> setVINReversas = new Set<String>();
        for(Movimiento__c objMovimiento: lstMovimientosFlotillas){
            setVINReversas.add(objMovimiento.VIN__r.Name);
        }

        //Mapa Edo Cuenta Vines Reversados
        List<TAM_DetalleEstadoCuenta__c>  lstEstadoCuenta = [SELECT	Id,
                                                                    TAM_VIN__c,
                                                                    TAM_Estatus_Finanzas__c,
                                                                    TAM_Fecha_Pago__c,
                                                                    TAM_NombreDealer__c,
                                                                    TAM_CodigoDealer__c,
                                                                    TAM_Monto_sin_IVA__c,
                                                                    TAM_IncentivoPropuestoDealer__c,
                                                                    TAM_EstatusVINEdoCta__c,
                                                                    RecordType.Name,
                                                                    TAM_Periodo__c,
                                                                    TAM_Anio_Incentivo__c,
                                                                    TAM_FechaFactura__c,
                                                                    TAM_Movimiento__c
                                                                    FROM 	TAM_DetalleEstadoCuenta__c
                                                                    WHERE	TAM_VIN__c IN: setVINReversas];
        Map<String, List<TAM_DetalleEstadoCuenta__c>> mapEdoCuenta = new Map<String, List<TAM_DetalleEstadoCuenta__c>>();
        List<TAM_DetalleEstadoCuenta__c> lstDetalleAux = new List<TAM_DetalleEstadoCuenta__c>();
        if(!lstEstadoCuenta.isEmpty()){
            for(TAM_DetalleEstadoCuenta__c objEdoCuenta : lstEstadoCuenta){
                String strVIN = objEdoCuenta.TAM_VIN__c;
                lstDetalleAux = mapEdoCuenta.get(strVIN);
                if(mapEdoCuenta.containsKey(strVIN)){
                    if(!lstDetalleAux.contains(objEdoCuenta)){
                        lstDetalleAux.add(objEdoCuenta);
                        mapEdoCuenta.put(strVIN, lstDetalleAux);
                    }
                } else {
                    lstDetalleAux = new List<TAM_DetalleEstadoCuenta__c>();
                    lstDetalleAux.add(objEdoCuenta);
                    mapEdoCuenta.put(strVIN, lstDetalleAux);
                }
            }
        }

        //validar movimientos
        for(Movimiento__c objMovimiento : lstMovimientosFlotillas){
            if(mapEdoCuenta != null && mapEdoCuenta.containsKey(objMovimiento.VIN__r.Name)){
                for(TAM_DetalleEstadoCuenta__c objEdoCuenta : mapEdoCuenta.get(objMovimiento.VIN__r.Name)){
                    Date fechaEnvio = objMovimiento.Submitted_Date__c.date();

                    //Validar que tenga movimiento en un rango de 3 meses.
                    if((objMovimiento.TAM_MesAnio__c == strMesAnioProv_1 || objMovimiento.TAM_MesAnio__c == strMesAnioProv_2 || objMovimiento.TAM_MesAnio__c == strMesAnioProv_3)){
                        if(objMovimiento.Trans_Type__c == 'RVRSL'){
                            strVINES.add(objMovimiento.VIN__r.Name);
                        }
                    }
                }
            }
        }
        
        for(Movimiento__c objMovimiento : lstMovimientosFlotillas){
            if(strVINES.contains(objMovimiento.VIN__r.Name)){
                String strmesDD = String.valueOf(objMovimiento.Submitted_Date__c.month());
                String stranioDD = String.valueOf(objMovimiento.Submitted_Date__c.year());
                String strMes = '';
                Double sumaIncentivos = 0.0;

                if(mapEdoCuenta != null && mapEdoCuenta.containsKey(objMovimiento.VIN__r.Name)){
                    TAM_DetalleProvisionIncentivo__c objDetalleProvision =  new TAM_DetalleProvisionIncentivo__c();
                    TAM_ModeloCodigoProducto__c objPasoModCodProd = mapModeloCodigoProd.containsKey(objMovimiento.Modelo__r.Name) ? mapModeloCodigoProd.get(objMovimiento.Modelo__r.Name) : new TAM_ModeloCodigoProducto__c();                                    

                    //Validación de suma total en estado de cuenta.
                    for(TAM_DetalleEstadoCuenta__c objDetalle : mapEdoCuenta.get(objMovimiento.VIN__r.Name)){
                        if(objDetalle.TAM_IncentivoPropuestoDealer__c != null){
                            sumaIncentivos =sumaIncentivos + objDetalle.TAM_IncentivoPropuestoDealer__c;
                        }
                    }

                    //Llenado de registros para detalle provisión de incentivos.
                    if(sumaIncentivos != 0){
                        for(TAM_DetalleEstadoCuenta__c objDetalleEdoCuenta : mapEdoCuenta.get(objMovimiento.VIN__r.Name)){
                            
                            if(objDetalleEdoCuenta.TAM_Estatus_Finanzas__c == STRING_ESTATUS_FINANZAS_PAGO_AUTORIZADO_TMEX ){

                                //Validación de suma total en estado de cuenta.
                                for(TAM_DetalleEstadoCuenta__c objDetalle : mapEdoCuenta.get(objMovimiento.VIN__r.Name)){
                                    if(objDetalle.TAM_IncentivoPropuestoDealer__c != null){
                                        sumaIncentivos =sumaIncentivos + objDetalle.TAM_IncentivoPropuestoDealer__c;
                                    }
                                }
                                if(mapMes.containsKey(objDetalleEdoCuenta.TAM_Periodo__c)){
                                    strMes = mapMes.get(objDetalleEdoCuenta.TAM_Periodo__c);
                                    strMes = strMes.toUpperCase();
                                }
                                
                                /*VIN*/				objDetalleProvision.TAM_VIN__c = objMovimiento.VIN__c;
                                /*CÓD. DEALER*/		objDetalleProvision.TAM_CodigoDealer__c = objMovimiento.Distribuidor__r.Codigo_Distribuidor__c;
                                /*NOM. DEALER*/		objDetalleProvision.TAM_NombreDealer__c = objMovimiento.Distribuidor__r.Name;
                                /*AÑO MODELO*/		objDetalleProvision.TAM_AnioModelo__c = objMovimiento.Year_Modelo__c;
                                /*MODELO*/			objDetalleProvision.TAM_Modelo__c = objMovimiento.Modelo__r.Name;
                                /*SERIE*/			objDetalleProvision.TAM_Serie__c = objMovimiento.TAM_Serie__c;
                                /*VERSIÓN*/			objDetalleProvision.TAM_Version__c = objMovimiento.Modelo__r.NombreVersion__c;
                                /*FECHA ENVÍO*/		objDetalleProvision.TAM_FechaEnvio__c = String.valueOf(objMovimiento.Submitted_Date__c);
                                /*FECHA VENTA*/		objDetalleProvision.TAM_FechaVenta__c = String.valueOf(objMovimiento.Sale_Date__c);
                                /*TIPO MOV.*/		objDetalleProvision.TAM_TipoMovimiento__c = objMovimiento.Trans_Type__c;
                                /*CÓD. VENTA*/		objDetalleProvision.TAM_CodigoVenta__c = objMovimiento.Sale_Code__c;
                                /*FIRST NAME*/		objDetalleProvision.TAM_FirstName__c = objMovimiento.First_Name__c;
                                /*LAST NAME */		objDetalleProvision.TAM_LastName__c = objMovimiento.Last_Name__c;
                                /*Fleet*/			objDetalleProvision.TAM_Fleet__c = objMovimiento.Fleet__c;
                                /*PROVISIONAR*/     objDetalleProvision.TAM_ProvicionarEfectivo__c = false;
                                /*TRANSMITIR */     objDetalleProvision.TAM_TransmitirDealer__c = false;

                                Date summitedDate = objMovimiento.Submitted_Date__c.date();
                                String strPeriodoDD = mapMesPorNum.get(objMovimiento.Month__c);
                                if(objMovimiento.Trans_Type__c == objDetalleEdoCuenta.TAM_Movimiento__c && objDetalleEdoCuenta.TAM_VIN__c == objMovimiento.VIN__r.Name){
                                    
                                        /*Edo.Cta*/     objDetalleProvision.TAM_DetalleEstadoCuenta__c = objDetalleEdoCuenta.Id;
                                        /*TIPO*/		objDetalleProvision.TAM_TipoRegEdoCuenta__c = objDetalleEdoCuenta.RecordType.Name;
                                        /*Incentivo */  objDetalleProvision.TAM_IncentivoTMEX_Efectivo__c = objDetalleEdoCuenta.TAM_IncentivoPropuestoDealer__c;
                                }

                                /*Provisión*/ 		objDetalleProvision.TAM_ProvisionIncentivos__c = recordId;
                                /*Clasificación*/	objDetalleProvision.TAM_Clasificacion__c = STRING_CLASIFICACION_CON_REVERSA;
                                /*Name	*/			objDetalleProvision.Name = objMovimiento.VIN__r.Name +'-'+ objMovimiento.TAM_Serie__c +'-'+ objMovimiento.Modelo__r.Name +'-'+objMovimiento.Year_Modelo__c +'-'+String.valueOf(objMovimiento.Submitted_Date__c)+'-'+objMovimiento.Trans_Type__c ;
                                /*Tipo Registro*/	objDetalleProvision.RecordTypeId = RecordTypeId;
                                
                                /*Id Externo	*/	objDetalleProvision.TAM_IdExterno__c = objMovimiento.VIN__r.Name +'-'+String.valueOf(objMovimiento.Submitted_Date__c) +'-'+objMovimiento.Trans_Type__c +'-'+ objMovimiento.Sale_Code__c +'-' +recordId +'-' + RecordTypeId + '-Reversa';
                                
                                if(!lstDetalleFlotilla_ConReversa.contains(objDetalleProvision)){
                                    if(mapVtaCorporativaFlotillaInventario.containsKey(objMovimiento.VIN__r.Name)){
                                        lstDetalleFlotilla_ConReversa.add(objDetalleProvision);
                                        /*SET REVERSAS*/    setReversas.add(objMovimiento.VIN__r.Name);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        //Guardado de datos
        if(!lstDetalleFlotilla_ConReversa.isEmpty()){
            try {
                Database.upsert(lstDetalleFlotilla_ConReversa, TAM_DetalleProvisionIncentivo__c.TAM_IdExterno__c);
            } catch (DmlException e) {
                System.debug(e.getMessage());
            }
        }
        return setReversas;
    }
}